-- define the dialog box for reseting config
StaticPopupDialogs["MONKEYSPEED_RESET"] = {
	text = TEXT(MONKEYSPEED_CONFIRM_RESET),
	button1 = TEXT(OKAY),
	button2 = TEXT(CANCEL),
	OnAccept = function()
		MonkeySpeed_ResetConfig()
		if (DEFAULT_CHAT_FRAME) then
			DEFAULT_CHAT_FRAME:AddMessage(MONKEYSPEED_RESET_MSG)
		end
	end,
	timeout = 0,
	exclusive = 1
}


-- Script array, not saved
MonkeySpeed = {}
MonkeySpeed.m_iDeltaTime = 0

MonkeySpeed.m_fSpeed = 0.0
MonkeySpeed.m_bLoaded = false
MonkeySpeed.m_bVariablesLoaded = false
MonkeySpeed.m_strPlayer = ""
MonkeySpeed.m_strUnit = "player"


function MonkeySpeed_Init()
	-- double check that we didn't already load
	if ((MonkeySpeed.m_bLoaded == false) and (MonkeySpeed.m_bVariablesLoaded == true)) then
		
		-- add the realm to the "player's name" for the config settings
		MonkeySpeed.m_strPlayer = GetCVar("realmName").."|"..MonkeySpeed.m_strPlayer
		
		if (not MonkeySpeedConfig) then
			MonkeySpeedConfig = { }
		end
		
		-- if there's not an entry for this
		if (not MonkeySpeedConfig[MonkeySpeed.m_strPlayer]) then
			MonkeySpeedConfig[MonkeySpeed.m_strPlayer] = {}
		end
		
		-- set the defaults if the values weren't loaded by the SavedVariables.lua
		if (MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bDisplay == nil) then
			MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bDisplay = true
		end
		if (MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bDisplayPercent == nil) then
			MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bDisplayPercent = true
		end
		if (MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bDisplayBar == nil) then
			MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bDisplayBar = true
		end
		if (MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_fUpdateRate == nil) then
			MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_fUpdateRate = 0.5
		end
		if (MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bLocked == nil) then
			MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bLocked = false
		end
		if (MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_iFrameWidth == nil) then
			MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_iFrameWidth = 48
		end
		if (MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_iFrameHeight == nil) then
			MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_iFrameHeight = 24
		end
		if (MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bAllowRightClick == nil) then
			MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bAllowRightClick = true
		end
		if (MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bAbsoluteSpeed == nil) then
			MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bAbsoluteSpeed = false
		end
		
		-- show or hide the right options
		if (MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bDisplay) then
			MonkeySpeedFrame:Show()
		else
			MonkeySpeedFrame:Hide()
		end
		
		if (MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bDisplayPercent) then
			MonkeySpeedText:Show()
		else
			MonkeySpeedText:Hide()
		end
		
		if (MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bDisplayBar) then
			MonkeySpeedBar:Show()
		else
			MonkeySpeedBar:Hide()
		end
		
		MonkeySpeedSlash_CmdSetWidth(MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_iFrameWidth)
		MonkeySpeedSlash_CmdSetHeight(MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_iFrameHeight)
		
		-- All variables are loaded now
		MonkeySpeed.m_bLoaded = true
		
		-- print out a nice message letting the user know the addon loaded
		if (DEFAULT_CHAT_FRAME) then
			DEFAULT_CHAT_FRAME:AddMessage(MONKEYSPEED_LOADED)
		end
	end
end

function MonkeySpeed_ResetConfig()
	-- set the defaults if the values weren't loaded by the SavedVariables.lua
	MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bDisplay = true
	MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bDisplayPercent = true
	MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bDisplayBar = true
	MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_fUpdateRate = 0.5
	MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bLocked = false
	MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_iFrameWidth = 48
	MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_iFrameHeight = 24
	MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bAllowRightClick = true
	MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_bAbsoluteSpeed = false
	
	-- show or hide the right options
	-- update the frame
	MonkeySpeedFrame:ClearAllPoints()
	MonkeySpeedFrame:SetPoint("TOP", "UIParent", "TOP", 150, 0)
	MonkeySpeedFrame:Show()
	
	MonkeySpeedText:Show()
	MonkeySpeedBar:Show()
	
	MonkeySpeedSlash_CmdSetWidth(MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_iFrameWidth)
	MonkeySpeedSlash_CmdSetHeight(MonkeySpeedConfig[MonkeySpeed.m_strPlayer].m_iFrameHeight)
	
	-- check for MonkeyBuddy
	if (MonkeyBuddySpeedFrame_Refresh ~= nil) then
		MonkeyBuddySpeedFrame_Refresh()
	end
end
